Bing Maps integration in JavaScript Maps component

Bing Maps is an online map service provider from Microsoft. Similar to OSM, it provides map tile images based on requests and combines those images into a single one to display the map area. Bing Maps offers various map styles including aerial imagery, road maps, and different canvas themes.

Prerequisites

Before using Bing Maps with the Maps component, the following prerequisites must be met:

  • Microsoft account - A Microsoft account is required to access the Bing Maps portal
  • Bing Maps key - A valid Bing Maps API key must be obtained for authentication

To obtain a Bing Maps key, visit the Bing Maps Dev Center and follow the instructions to create a new key. The key must be appended to the Bing Maps URL before passing it to the getBingUrlTemplate method.

Adding Bing Maps

Bing Maps can be rendered using the urlTemplate property with a URL generated by the getBingUrlTemplate method. Since Bing Maps uses a different URL format compared to other map providers, the Maps component provides a built-in getBingUrlTemplate method that converts the Bing Maps URL into the required format.

The getBingUrlTemplate method is asynchronous and returns a Promise. Replace the key=? placeholder in the Bing Maps URL with the actual API key obtained from the Bing Maps Dev Center. The URL returned by this method should be assigned to the urlTemplate property within the Promise’s then callback.

var map = new ej.maps.Maps({
    load: function(args){
        args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            args.maps.layers[0].urlTemplate= url;
        });
    },
    layers:[{
    }]
});
map.appendTo('container');

Types of Bing Maps

Bing Maps provides different map styles, all of which are supported in the Maps component.

  • Aerial - Displays satellite images to highlight roads and major landmarks for easy identification.
  • AerialWithLabel - Displays aerial maps with labels for continents, countries, oceans, and other geographic features.
  • Road - Displays the default map view of roads, buildings, and geographic features.
  • CanvasDark - Displays a dark version of the road maps.
  • CanvasLight - Displays a light version of the road maps.
  • CanvasGray - Displays a grayscale version of the road maps.

To render a specific map style, specify the desired type (such as CanvasLight) in the URL passed to the getBingUrlTemplate method, as demonstrated in the following code sample.

var map = new ej.maps.Maps({
    load: function(args){
        args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/CanvasLight?output=json&uriScheme=https&key=?").then(function(url) {
           args.maps.layers[0].urlTemplate= url;
        });
    },
    zoomSettings: {
        zoomFactor: 12,
    },
    centerPosition : {
        latitude: 38.8951,
        longitude: -77.0364
    },
    layers:[{
    }]
});
map.appendTo('container');

Enabling zooming and panning

The Bing Maps layer supports zooming and panning interactions for enhanced map exploration. Zooming provides a closer view of specific areas for detailed analysis, while panning allows navigation across different regions of the map. These features can be enabled using the zoomSettings property with toolbar controls for user interaction.

var map = new ej.maps.Maps({
    load: function(args){
        args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            args.maps.layers[0].urlTemplate= url;
        });
    },
    zoomSettings: {
        enable: true,
        toolbarSettings: {
            buttonSettings: {
                toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
            }
        }
    },
    layers: [{
    }]
});
map.appendTo('container');

Adding markers and navigation line

Markers can be added to Bing Maps layers to highlight specific locations by setting the latitude and longitude coordinates using markerSettings. Navigation lines can be drawn on top of the Bing Maps layer to visualize routes or connections between locations by configuring the navigationLineSettings with corresponding latitude and longitude coordinates.

var map = new ej.maps.Maps({
    load: function(args){
        args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            args.maps.layers[0].urlTemplate= url;
        });
    },
    zoomSettings: {
        zoomFactor: 4
    },
    centerPosition: {
        latitude: 29.394708
        logitude: -94.954653
    },
    layers: [{
        markerSettings: [{
            visible: true,
            height: 25,
            width: 15,
            dataSouce: [{
                latitude: 34.060620,
                longitude: -118.330491,
                name: "California"
            },
            {
                latitude: 40.724546,
                longitude: -73.850344,
                name: "New York"
            }],
        }],
        navigationLineSettings: [{
            visible: true,
            color: "blue",
            angle: 0.1,
            latitude: {
                34.060620, 40.724546
            },
            longitude: {
                -118.330491, -73.850344
            }
        }]
    }]
});
map.appendTo('container');

Adding sublayer

GeoJSON shapes can be rendered as a sublayer on top of the Bing Maps base layer to highlight specific regions such as continents, countries, or custom geographic areas. This is accomplished by adding an additional layer and setting the type property to SubLayer. The sublayer overlays the Bing Maps tiles while maintaining interactivity with the base map.

var map = new ej.maps.Maps({
    load: function(args){
        args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
           args.maps.layers[0].urlTemplate= url;
        });
    },
    layers: [
        {
           // Add Bing Map.
        },
        {
            shapeData: Africa_Continent,
            type: 'SubLayer',
            shapeSettings: {
                fill: "blue"
            }
        }
    ]
});
map.appendTo('container');

Enabling legend

The legend can be added to the tile Maps by setting the visible property of legendSettings to true.

var map = new ej.maps.Maps({
    load: function(args){
        args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
           args.maps.layers[0].urlTemplate= url;
        });
    },
    legendSettings: {
        visible: true,
        type: 'Markers',
        useMarkerShape:true,
        toggleLegendSettings: {
          enable: true,
          applyShapeSettings: false,
          border: {
            color: 'green',
            width: 2
          }
        }
    },
    layers: [
        {
          shapeDataPath: 'name',
          shapePropertyPath: 'name',
          shapeSettings: {
            fill: '#E5E5E5'
          },
          markerSettings: [
            {
              dataSource: markerDataSource,
              colorValuePath: 'color',
              shapeValuePath:'shape',
              legendText: 'country',
              visible: true
            }
          ]
        }
    ]
});
map.appendTo('#element');

Bing maps integration in Vue Maps component

Bing Maps is a online Maps provider, owned by Microsoft. As like OSM, it provide Maps tile images based on our requests and combines those images into a single one to display Maps area.

Prerequisites

Before using Bing Maps with the Maps component, the following prerequisites must be met:

  • Microsoft account - A Microsoft account is required to access the Bing Maps portal
  • Bing Maps key - A valid Bing Maps API key must be obtained for authentication

To obtain a Bing Maps key, visit the Bing Maps Dev Center and follow the instructions to create a new key. The key must be appended to the Bing Maps URL before passing it to the getBingUrlTemplate method.

Adding Bing Maps

Bing Maps can be rendered using the urlTemplate property with a URL generated by the getBingUrlTemplate method. Since Bing Maps uses a different URL format compared to other map providers, the Maps component provides a built-in getBingUrlTemplate method that converts the Bing Maps URL into the required format.

The getBingUrlTemplate method is asynchronous and returns a Promise. Replace the key=? placeholder in the Bing Maps URL with the actual API key obtained from the Bing Maps Dev Center. The URL returned by this method should be assigned to the urlTemplate property within the Promise’s then callback.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps id='container' :layers='layers' :load='load'>
            </ejs-maps>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { MapsPlugin } from '@syncfusion/ej2-vue-maps';
Vue.use(MapsPlugin);
export default {
data () {
    return {
      layers: [
        {
        }
    ]
    }
},
methods:{
    load: function (args) {
        let map=document.getElementById('container');
        map.ej2_instances[0].getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            map.ej2_instances[0].layers[0].urlTemplate= url;
        });
    }
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Types of Bing Maps

Bing Maps provides different map styles, all of which are supported in the Maps component.

  • Aerial - Displays satellite images to highlight roads and major landmarks for easy identification.
  • AerialWithLabel - Displays aerial maps with labels for continents, countries, oceans, and other geographic features.
  • Road - Displays the default map view of roads, buildings, and geographic features.
  • CanvasDark - Displays a dark version of the road maps.
  • CanvasLight - Displays a light version of the road maps.
  • CanvasGray - Displays a grayscale version of the road maps.

To render a specific map style, specify the desired type (such as CanvasLight) in the URL passed to thegetBingUrlTemplate method, as demonstrated in the following code sample.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps id='container' :centerPosition="centerPosition" :layers='layers' :load='load'>
            </ejs-maps>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { MapsPlugin} from '@syncfusion/ej2-vue-maps';
Vue.use(MapsPlugin);
export default {
data () {
    return{
        layers: [{
        }],
        centerPosition: {
            latitude: 38.8951,
            longitude: -77.0364
        }
    }
},
methods:{
    load: function (args) {
        let map=document.getElementById('container');
        map.ej2_instances[0].getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/CanvasLight?output=json&uriScheme=https&key=?").then(function(url) {
            map.ej2_instances[0].layers[0].urlTemplate= url;
        });
    }
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Enabling zooming and panning

The Bing Maps layer supports zooming and panning interactions for enhanced map exploration. Zooming provides a closer view of specific areas for detailed analysis, while panning allows navigation across different regions of the map. These features can be enabled using the zoomSettings property with toolbar controls for user interaction.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps  id='container' :zoomSettings='zoomSettings' :layers='layers' :load='load'>
            </ejs-maps>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { MapsPlugin, Zoom } from '@syncfusion/ej2-vue-maps';
Vue.use(MapsPlugin);
export default {
data () {
    return{
        zoomSettings: {
            enable: true,
            toolbarSettings:{
               buttonSettings: {
                   toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
               }
            }
        },
        layers: [{
        }]
    }
},
provide: {
    maps: [Zoom]
},
methods:{
    load: function (args) {
        let map=document.getElementById('container');
        map.ej2_instances[0].getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            map.ej2_instances[0].layers[0].urlTemplate= url;
        });
    }
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Adding markers and navigation line

Markers can be added to Bing Maps layers to highlight specific locations by setting the latitude and longitude coordinates using markerSettings. Navigation lines can be drawn on top of the Bing Maps layer to visualize routes or connections between locations by configuring the navigationLineSettings with corresponding latitude and longitude coordinates.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps id='container' :zoomSettings='zoomSettings' :load='load' :centerPosition= 'centerPosition'>
            <e-layers>
                    <e-layer>
                        <e-markerSettings>
                            <e-markerSetting visible= true height=25 width=15 :dataSource ="dataSource" ></e-markerSetting>
                            <e-markerSetting visible= true height=25 width=15 :dataSource ="dataSource1"></e-markerSetting>
                        </e-markerSettings>
                        <e-navigationLineSettings>
                            <e-navigationLineSetting visible = true :latitude ='latitude' :longitude ='longitude' :color ='color' :angle ='angle' :width="width">
                            </e-navigationLineSetting>
                        </e-navigationLineSettings>
                    </e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { MapsPlugin, Zoom, Marker, NavigationLine } from '@syncfusion/ej2-vue-maps';
Vue.use(MapsPlugin);
export default {
data () {
    return{
        zoomSettings: {
           zoomFactor: 4
       },
       centerPosition: {
           latitude: 29.394708,
           longitude: -94.954653
       },
       dataSource: [
            {
                latitude: 34.060620,
                longitude: -118.330491,
                name: "California"
        }],
        dataSource1: [
            {
                latitude: 40.724546,
                longitude: -73.850344,
                name: "New York"
        }],
        color: "blue",
        width: 5,
        angle: 0.1,
        latitude: [34.060620, 40.724546],
        longitude: [-118.330491,-73.850344]
    }
},
provide: {
    maps: [Zoom, Marker, NavigationLine]
},
methods:{
    load: function (args) {
        let map=document.getElementById('container');
        map.ej2_instances[0].getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            map.ej2_instances[0].layers[0].urlTemplate= url;
        });
    }
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Adding sublayer

GeoJSON shapes can be rendered as a sublayer on top of the Bing Maps base layer to highlight specific regions such as continents, countries, or custom geographic areas. This is accomplished by adding an additional layer and setting the type property to SubLayer. The sublayer overlays the Bing Maps tiles while maintaining interactivity with the base map.

<template>
    <div id="app">
          <div>
            <ejs-maps id='container' :layers='layers' :load='load'>
            </ejs-maps>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { MapsPlugin } from '@syncfusion/ej2-vue-maps';
import { africa } from './africa.js';
Vue.use(MapsPlugin);
export default {
data () {
    return {
        layers: [{
        },
        {
            type: 'SubLayer',
            shapeData: africa,
            shapeSettings: {
                fill: 'blue'
            }
        }
    ]
    }
},
methods:{
    load: function (args) {
        let map=document.getElementById('container');
        map.ej2_instances[0].getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            map.ej2_instances[0].layers[0].urlTemplate= url;
        });
    }
}
}
</script>

Enabling legend

The legend can be added to the tile Maps by setting the visible property of legendSettings to true.

<template>
    <div id="app">
        <div class='wrapper'>
            <ejs-maps id='container' :legendSettings='legendSettings' :load='load'>
            <e-layers>
                <e-layer :shapeSettings='shapeSettings' :markerSettings='markerSettings'></e-layer>
            </e-layers>
        </ejs-maps>
        </div>
    </div>
</template>

<script>
import Vue from 'vue';
import { MapsPlugin, Marker, Legend } from '@syncfusion/ej2-vue-maps';
import { markerDataSource } from './marker-data.js';
Vue.use(MapsPlugin);
export default {
data () {
    return {
        legendSettings: {
            visible: true,
            type: 'Markers',
            useMarkerShape:true,
            toggleLegendSettings: {
                enable: true,
                applyShapeSettings: false,
                border: {
                    color: 'green',
                    width: 2
                }
            }
        },
        shapeSettings: {
            fill: '#E5E5E5'
        },
        markerSettings: [
            {
                colorValuePath: 'color',
                shapeValuePath:'shape',
                legendText: 'country',
                visible: true,
                dataSource: markerDataSource
            }
        ]
    }
},
provide: {
    maps: [Legend, Marker]
},
methods:{
    load: function (args) {
        let map=document.getElementById('container');
        map.ej2_instances[0].getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
            map.ej2_instances[0].layers[0].urlTemplate= url;
        });
    }
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Bing maps integration in React Maps component

Bing Maps is a online Maps provider, owned by Microsoft. As like OSM, it provide Maps tile images based on our requests and combines those images into a single one to display Maps area.

Prerequisites

Before using Bing Maps with the Maps component, the following prerequisites must be met:

  • Microsoft account - A Microsoft account is required to access the Bing Maps portal
  • Bing Maps key - A valid Bing Maps API key must be obtained for authentication

To obtain a Bing Maps key, visit the Bing Maps Dev Center and follow the instructions to create a new key. The key must be appended to the Bing Maps URL before passing it to the getBingUrlTemplate method.

Adding Bing Maps

Bing Maps can be rendered using the urlTemplate property with a URL generated by the getBingUrlTemplate method. Since Bing Maps uses a different URL format compared to other map providers, the Maps component provides a built-in getBingUrlTemplate method that converts the Bing Maps URL into the required format.

The getBingUrlTemplate method is asynchronous and returns a Promise. Replace the key=? placeholder in the Bing Maps URL with the actual API key obtained from the Bing Maps Dev Center. The URL returned by this method should be assigned to the urlTemplate property within the Promise’s then callback.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective } from '@syncfusion/ej2-react-maps';

function load(args) {
    args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
    });
}
export function App() {
    return(
            <MapsComponent load={load}>
                <LayersDirective>
                    <LayerDirective />
                </LayersDirective>
            </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Types of Bing Maps

Bing Maps provides different map styles, all of which are supported in the Maps component.

  • Aerial - Displays satellite images to highlight roads and major landmarks for easy identification.
  • AerialWithLabel - Displays aerial maps with labels for continents, countries, oceans, and other geographic features.
  • Road - Displays the default map view of roads, buildings, and geographic features.
  • CanvasDark - Displays a dark version of the road maps.
  • CanvasLight - Displays a light version of the road maps.
  • CanvasGray - Displays a grayscale version of the road maps.

To render a specific map style, specify the desired type (such as CanvasLight) in the URL passed to thegetBingUrlTemplate method, as demonstrated in the following code sample.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Zoom, Inject } from '@syncfusion/ej2-react-maps';

function load(args) {
    args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/CanvasLight?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
    });
}

export function App() {
    return(
            <MapsComponent zoomSettings= {{ zoomFactor: 4 }}
                                    centerPosition = {{
                                        latitude : 38.8951,
                                        longitude : -77.0364
                                    }} load={load}>
                <Inject services={[Zoom]} />
                <LayersDirective>
                    <LayerDirective />
                </LayersDirective>
            </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Enabling zooming and panning

The Bing Maps layer supports zooming and panning interactions for enhanced map exploration. Zooming provides a closer view of specific areas for detailed analysis, while panning allows navigation across different regions of the map. These features can be enabled using the zoomSettings property with toolbar controls for user interaction.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Zoom, Inject } from '@syncfusion/ej2-react-maps';

function load(args) {
    args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
    });
}

export function App() {
    return(
            <MapsComponent load={load} zoomSettings= {{
                                        enable : true,
                                        toolbarSettings:{
                                            buttonSettings: {
                                            toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
                                        }
                }}}>
                <Inject services={[Zoom]} />
                <LayersDirective>
                    <LayerDirective />
                </LayersDirective>
            </MapsComponent>
    );
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Adding markers and navigation line

Markers can be added to Bing Maps layers to highlight specific locations by setting the latitude and longitude coordinates using MarkerDirective. Navigation lines can be drawn on top of the Bing Maps layer to visualize routes or connections between locations by configuring the NavigationLineDirective with corresponding latitude and longitude coordinates.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, MarkersDirective, NavigationLineDirective, NavigationLinesDirective, MarkerDirective, LayersDirective, LayerDirective, Inject, Zoom, Marker, NavigationLine } from '@syncfusion/ej2-react-maps';

function load(args) {
    args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
    });
}

export function App() {
return (
            <MapsComponent load={load} zoomSettings= {{
                                        zoomFactor : 4
                                        }}
                                        centerPosition = {{
                                            latitude: 29.394708,
                                            longitude: -94.954653
                                        }}>
            <Inject services={[Zoom, Marker, NavigationLine]} />
                <LayersDirective>
                    <LayerDirective>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={25}
                                            width={15}
                                            dataSource={[
                                                {
                                                    latitude: 34.060620,
                                                    longitude: -118.330491,
                                                    name: "California"
                                                },
                                                {
                                                    latitude: 40.724546,
                                                    longitude: -73.850344,
                                                    name: "New York"
                                                }
                                            ]}
                                        >
                            </MarkerDirective>
                        </MarkersDirective>
                        <NavigationLinesDirective>
                            <NavigationLineDirective visible={true}
                                                     latitude={[34.060620, 40.724546]}
                                                     longitude={[-118.330491,-73.850344]}
                                                     color="blue"
                                                     angle={90}
                                                     width={5} />
                        </NavigationLinesDirective>
                    </LayerDirective>
                </LayersDirective>
            </MapsComponent>
);
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Adding sublayer

GeoJSON shapes can be rendered as a sublayer on top of the Bing Maps base layer to highlight specific regions such as continents, countries, or custom geographic areas. This is accomplished by adding an additional layer and setting the type property to SubLayer. The sublayer overlays the Bing Maps tiles while maintaining interactivity with the base map.

import { africa } from 'africa_continent.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective } from '@syncfusion/ej2-react-maps';

function load(args) {
    args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
    });
}

export function App() {
return(
            <MapsComponent load={load}>
                <LayersDirective>
                    <LayerDirective/>
                    <LayerDirective shapeData= {africa_continent}
                                    type= 'SubLayer'
                                    shapeSettings= {{
                                        fill: 'blue'
                                    }}
                    />
                </LayersDirective>
            </MapsComponent>
);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Enabling legend

The legend can be added to the tile Maps by setting the visible property of legendSettings to true.

import { markerDataSource } from 'markerdata.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, Marker, MarkersDirective, MarkerDirective, Legend, Inject } from '@syncfusion/ej2-react-maps';

function load(args) {
    args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
    });
}

export function App() {
return(
            <MapsComponent
              load={load}
              legendSettings={{
                visible: true,
                type: 'Markers',
                useMarkerShape: true,
                toggleLegendSettings: {
                  enable: true,
                  applyShapeSettings: false,
                  border: {
                    color: 'green',
                    width: 2,
                  },
                },
              }}
            >
              <Inject services={[Marker, Legend]} />
              <LayersDirective>
                <LayerDirective>
                  <MarkersDirective>
                    <MarkerDirective
                      visible={true}
                      dataSource={markerDataSource}
                      colorValuePath="color"
                      shapeValuePath="shape"
                      legendText="country"
                    ></MarkerDirective>
                  </MarkersDirective>
                </LayerDirective>
              </LayersDirective>
            </MapsComponent>
);
}

const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Bing maps integration in Angular Maps component

Bing Maps is a online Maps provider, owned by Microsoft. As like OSM, it provide Maps tile images based on our requests and combines those images into a single one to display Maps area.

Prerequisites

Before using Bing Maps with the Maps component, the following prerequisites must be met:

  • Microsoft account - A Microsoft account is required to access the Bing Maps portal
  • Bing Maps key - A valid Bing Maps API key must be obtained for authentication

To obtain a Bing Maps key, visit the Bing Maps Dev Center and follow the instructions to create a new key. The key must be appended to the Bing Maps URL before passing it to the getBingUrlTemplate method.

Adding Bing Maps

Bing Maps can be rendered using the urlTemplate property with a URL generated by the getBingUrlTemplate method. Since Bing Maps uses a different URL format compared to other map providers, the Maps component provides a built-in getBingUrlTemplate method that converts the Bing Maps URL into the required format.

The getBingUrlTemplate method is asynchronous and returns a Promise. Replace the key=? placeholder in the Bing Maps URL with the actual API key obtained from the Bing Maps Dev Center. The URL returned by this method should be assigned to the urlTemplate property within the Promise’s then callback.

import { Component, OnInit } from '@angular/core';
import { ILoadEventArgs } from '@syncfusion/ej2-angular-maps';

@Component({
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container' (load)="load($event)" style="display:block">
     <e-layers>
    <e-layer></e-layer>
    </e-layers>
    </ejs-maps>`
})
export class AppComponent implements OnInit {
    public load = (args: ILoadEventArgs) : void => {
      args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
      });
    };
}

Types of Bing Maps

Bing Maps provides different map styles, all of which are supported in the Maps component.

  • Aerial - Displays satellite images to highlight roads and major landmarks for easy identification.
  • AerialWithLabel - Displays aerial maps with labels for continents, countries, oceans, and other geographic features.
  • Road - Displays the default map view of roads, buildings, and geographic features.
  • CanvasDark - Displays a dark version of the road maps.
  • CanvasLight - Displays a light version of the road maps.
  • CanvasGray - Displays a grayscale version of the road maps.

To render a specific map style, specify the desired type (such as CanvasLight) in the URL passed to thegetBingUrlTemplate method, as demonstrated in the following code sample.

import { Component, OnInit} from '@angular/core';
import { ILoadEventArgs } from '@syncfusion/ej2-angular-maps';

@Component({
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container' (load)="load($event)" style="display:block">
     <e-layers>
    <e-layer></e-layer>
    </e-layers>
    </ejs-maps>`
})
export class AppComponent implements OnInit {
     public load = (args: ILoadEventArgs) : void => {
      args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/CanvasLight?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
      });
    };
}

Enabling zooming and panning

The Bing Maps layer supports zooming and panning interactions for enhanced map exploration. Zooming provides a closer view of specific areas for detailed analysis, while panning allows navigation across different regions of the map. These features can be enabled using the zoomSettings property with toolbar controls for user interaction.

import { Component, OnInit, Inject } from '@angular/core';
import { Maps, Zoom, ILoadEventArgs } from '@syncfusion/ej2-angular-maps';

Maps.Inject(Zoom);
@Component({
  selector: 'app-container',
  template: `
    <ejs-maps id="rn-container" (load)="load($event)" [zoomSettings]="zoomSettings" style="display:block">
      <e-layers>
        <e-layer></e-layer>
      </e-layers>
    </ejs-maps>
  `
})
export class AppComponent implements OnInit {
  public zoomSettings: object;
  ngOnInit(): void {
      this.zoomSettings = {
          enable:true,
          toolbarSettings: {
              buttonSettings: {
                  toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset'],
              }
          }
    };
    public load = (args: ILoadEventArgs) : void => {
      args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
      });
    };
  }
}

Adding markers and navigation line

Markers can be added to Bing Maps layers to highlight specific locations by setting the latitude and longitude coordinates using markerSettings. Navigation lines can be drawn on top of the Bing Maps layer to visualize routes or connections between locations by configuring the navigationLineSettings with corresponding latitude and longitude coordinates.

import { Component, OnInit, Inject } from '@angular/core';
import { Maps, Zoom, Marker, NavigationLine, ILoadEventArgs } from '@syncfusion/ej2-angular-maps';

Maps.Inject(Zoom, Marker, NavigationLine);
@Component({
  selector: 'app-container',
  template: `
    <ejs-maps id="rn-container" (load)="load($event)" style="display:block" [zoomSettings]="zoomSettings" [centerPosition]="centerPosition">
      <e-layers>
        <e-layer [markerSettings]="markerSettings" [navigationLineSettings]="navigationLineSettings"></e-layer>
      </e-layers>
    </ejs-maps>
  `
})
export class AppComponent implements OnInit {
  
  public zoomSettings: object;
  public centerPosition: object;
  public markerSettings: object;
  public navigationLineSettings: object;
  public load = (args: ILoadEventArgs) : void => {
      args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
      });
  };
  ngOnInit(): void {
    this.zoomSettings = {
      zoomFactor: 4
    };
    this.centerPosition = {
      latitude: 29.394708,
      longitude: -94.954653
    };
    this.markerSettings = [
      {
        visible: true,
        height: 25,
        width: 15,
        dataSource: [
          {
            latitude: 34.06062,
            longitude: -118.330491,
            name: 'California'
          },
          {
            latitude: 40.724546,
            longitude: -73.850344,
            name: 'New York'
          }
        ]
      }
    ];
    this.navigationLineSettings = [
    {
        visible: true,
        color: 'blue',
        width: 5,
        angle: 0.1,
        latitude: [34.06062, 40.724546],
        longitude: [-118.330491, -73.850344]
    }];
  }
}

Adding sublayer

GeoJSON shapes can be rendered as a sublayer on top of the Bing Maps base layer to highlight specific regions such as continents, countries, or custom geographic areas. This is accomplished by adding an additional layer and setting the type property to SubLayer. The sublayer overlays the Bing Maps tiles while maintaining interactivity with the base map.

import { Component, OnInit } from '@angular/core';
import { Maps, ILoadEventArgs } from '@syncfusion/ej2-angular-maps';
import { africa_continent } from 'africa-continent.ts';

@Component({
    selector: 'app-container',
    template:
    `<ejs-maps (load)="load($event)" id='rn-container' style="display:block">
    <e-layers>
    <e-layer></e-layer>
     <e-layer [shapeData]= 'shapeData' [type] ='Sublayer' [shapeSettings]='shapeSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public load = (args: ILoadEventArgs) : void => {
      args.maps.getBingUrlTemplate("https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?").then(function(url) {
        args.maps.layers[0].urlTemplate= url;
      });
    };
    public shapeData: object;
    public shapeSettings: object;
    ngOnInit(): void {
        this.shapeData = africa_continent;
        this.shapeSettings = {
            fill: 'blue'
        }
    }
}

Enabling legend

The legend can be added to the tile Maps by setting the visible property of legendSettings to true.

import { Component, OnInit } from '@angular/core';
import { Maps, ILoadEventArgs } from '@syncfusion/ej2-angular-maps';
import { markerDataSource } from 'markerdata.ts';

@Component({
    selector: 'app-container',
    template:
    `<ejs-maps
      id="rn-container"
      (load)="load($event)"
      style="display:block"
      [legendSettings]="legendSettings"
    >
      <e-layers>
        <e-layer
          [shapePropertyPath]="shapePropertyPath"
          [shapeDataPath]="shapeDataPath"
          [markerSettings]="markerSettings"
          [shapeSettings]="shapeSettings"
        ></e-layer>
      </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
  public load = (args: ILoadEventArgs): void => {
    args.maps
      .getBingUrlTemplate(
        'https://dev.virtualearth.net/REST/V1/Imagery/Metadata/Aerial?output=json&uriScheme=https&key=?'
      )
      .then(function (url) {
        args.maps.layers[0].urlTemplate = url;
      });
  };
  public shapeDataPath: string;
  public shapePropertyPath: string;
  public shapeSettings: object;
  public markerSettings: object;
  public legendSettings: object;
  ngOnInit(): void {
    this.shapeDataPath = 'name';
    this.shapePropertyPath = 'name';
    this.legendSettings = {
      visible: true,
      type: 'Markers',
      useMarkerShape: true,
      toggleLegendSettings: {
        enable: true,
        applyShapeSettings: false,
        border: {
          color: 'green',
          width: 2,
        },
      },
    };
    this.shapeSettings = {
      fill: '#E5E5E5',
    };
    this.markerSettings = [
      {
        dataSource: markerDataSource,
        colorValuePath: 'color',
        shapeValuePath: 'shape',
        legendText: 'country',
        visible: true,
      },
    ];
  }
}